#include "dcf77.h"
#include "time.h"


//FIXME muss unabhngig werden
#include "lcd_routines.h"
#include "prop.h"

#include <avr/interrupt.h>

void dcf_init() {

	dcf_min = 0;
	dcf_hrs = 0;

	dcf_is_on = 0; //TODO ersetzten durch lesen des ports
	dcf_active = 0;
	dcf_break_timer = 0;
	dcf_bit_pos = 0;
	dcf_high_timer = 0;
	//dcf_bits[58];

	DCF_DDR &= ~(1 << DCF); //configure dcf port for input
	DCF_SWTH_DDR |= (1<<DCF_SWTH); // confgure dcf switch port for output

	// Signalinterrupt fr DCF_INT Port aktivieren
	GIMSK |= (1 << DCF_INT);
	//Steigende Flanke erkennen
	DCF_FLANK;
	// Beim booten einen Sync machen
	dcf_sync = 1;
}

void dcf_on() {
	if (!dcf_is_on) { // Wenn das DCF Modul abgeschalten ist, wird es ein geschalten
		dcf_is_on = 1;
		//GIMSK |= (1 << DCF_INT); // aktiviert sich von allein
		DCF_SWTH_PORT |= (1 << DCF_SWTH);
	}
}

void dcf_off() {
	if (dcf_is_on) {
		dcf_is_on = 0;
		// Interrupt muss nicht deaktiviert werden, da er zum Zeitpunkt eines sinnvollen Aufrufs bereits aus ist
		DCF_SWTH_PORT &= ~(1 << DCF_SWTH);
	}
}

uint8_t dcf_parse() {
	dcf_min = 0;
	dcf_hrs = 0;
	uint8_t parity_hrs = 0;
	uint8_t parity_min = 0;

	//Stunden
	if (dcf_bits[29]) { //stunde 1
		dcf_hrs = 1;
		parity_hrs++;
	}
	if (dcf_bits[30]) { //stunde 2
		dcf_hrs += 2;
		parity_hrs++;
	}
	if (dcf_bits[31]) { //stunde 4
		dcf_hrs += 4;
		parity_hrs++;
	}
	if (dcf_bits[32]) { //stunde 8
		dcf_hrs += 8;
		parity_hrs++;
	}
	if (dcf_bits[33]) { //stunde 10
		dcf_hrs += 10;
		parity_hrs++;
	}
	if (dcf_bits[34]) { //stunde 20
		dcf_hrs += 20;
		parity_hrs++;
	}

	if (dcf_bits[35]) { //Prfbit ok ?
		if (parity_hrs == 1 || parity_hrs == 3 || parity_hrs == 5) {
		} else {
			return 0;
		}
	} else { //Prfbit ok ?
		if (parity_hrs == 0 || parity_hrs == 2 || parity_hrs == 4 || parity_hrs
				== 6) {
		} else {
			return 0;
		}
	}

	//Minuten
	if (dcf_bits[21]) { //minute 1
		dcf_min = 1;
		parity_min++;
	}
	if (dcf_bits[22]) { //minute 2
		dcf_min += 2;
		parity_min++;
	}
	if (dcf_bits[23]) { //minute 4
		dcf_min += 4;
		parity_min++;
	}
	if (dcf_bits[24]) { //minute 8
		dcf_min += 8;
		parity_min++;
	}
	if (dcf_bits[25]) { //minute 10
		dcf_min += 10;
		parity_min++;
	}
	if (dcf_bits[26]) { //minute 20
		dcf_min += 20;
		parity_min++;
	}
	if (dcf_bits[27]) { //minute 40
		dcf_min += 40;
		parity_min++;
	}

	if (dcf_bits[28]) { //Prfbit ok ?
		if (parity_min == 1 || parity_min == 3 || parity_min == 5 || parity_min
				== 7) {
		} else {
			return 0;
		}
	} else { //Prfbit ok ?
		if (parity_min == 0 || parity_min == 2 || parity_min == 4 || parity_min
				== 6) {
		} else {
			return 0;
		}
	}

	return (parity_min & parity_hrs);
}

void dcf_ISRoutine() {
	if (dcf_sync) {
		dcf_on();
		if (dcf_active) { // wenn gerade ein DCF-Signal-Bit empfangen wird
			if (dcf_break_timer > 95) { //Wenn es das leer Bit davor war (lnger als 95 Zyklen (knappe 1 sec) low)

				if (dcf_bit_pos >= 58) { //Wenn alle 58 bit empfangen wurden

					if (dcf_parse()) { //Wenn das Parsen geklappt hat
						dcf_sync--;
						if (dcf_sync) { // wenn noch nicht genug syncs, aktiviere interrupt
							GIMSK |= (1 << DCF_INT);
						}
						// Zeit bernehmen
						//FIXME als rckgabe
						seconds = 0;
						minutes = dcf_min;
						hours = dcf_hrs;
						lcd_clear();
						dcf_off();
					}
				}

				// Variablen zurck setzten und beenden
				dcf_break_timer = 0;
				dcf_bit_pos = 0;
				GIMSK |= (1 << DCF_INT);

			} else {
				dcf_break_timer = 0; // Timer zurcksetzten weil ein Bit erkannt ist

				// Herausfinden ob das Bit 1 oder 0 ist
				if (DCF_PIN & (1 << DCF)) { //noch High-Pegel
					dcf_high_timer++; //Zeit des H-Pegels zhlen

				} else { //jetzt Low-Pegel --> Bit bertragen

					// entscheiden ob es 1 oder 0 war
					if (dcf_high_timer <= 11) { // wenn der High-Pegel 0,04 - 0,13 (scheinbar nur bis 0,11) sec dann wars 0 (da 1 interrupt alle 1/100 sec --> 13)
						dcf_bits[dcf_bit_pos] = 0;
					} else { // wenn der High-Pegel 0,14 - 0,23 sec dann wars 1
						dcf_bits[dcf_bit_pos] = 1;
					}

					// Variablen setzen und interrupt wieder aktivieren
					dcf_bit_pos++;
					dcf_active = 0;
					dcf_high_timer = 0;
					GIMSK |= (1 << DCF_INT);
				}
			}

		} else {
			// gerade kein Signal;
			// der Timer hilft fest zu stellen ob gerade das 0 bit empfangen wird
			dcf_break_timer++;
		}
	}
}

void dcf_INT_Routine() {
	TCNT0 = 0; //Rcksetzen des "Zhltimers"
	dcf_active = 1;

	GIMSK &= ~(1 << DCF_INT); //deaktivieren des externen Interrupts, wenn
	//Bit komplett, wird er wieder aktiviert
	//FIXME vorrbergehend
	SWTH_PORT ^= (1 << 3);
}

