#ifndef __DCF77_H
#define __DCF77_H

#include <avr/io.h>

// Fr Signalerfassung
#define DCF_DDR 			DDRD
//#define DCF_PORT 			PORTD
#define DCF_PIN				PIND
#define DCF				 	2		// DFC Siganl Eingang

#define DCF_INT				INT0
#define DCF_ISR				INT0_vect
#define DCF_FLANK			MCUCR |= (1 << ISC01) | (1 << ISC00) // ISCx1 und ISCx0 bei INTx

// Um das Modul zu Deaktivieren
#define DCF_SWTH_DDR 		DDRD
#define DCF_SWTH_PORT		PORTD
#define DCF_SWTH			4

// Aktivierung und Deaktivierung der Syncronisierung
#define DCF_SYNC_PERIODE 2; //2 erfolgreiche syncs
volatile uint8_t dcf_sync;


// ACHTUNG:
// Ein Timer muss Initialisiert werden die entsprechende ISR ausfren im entsprechenden Zeitraum



uint8_t dcf_min;
uint8_t dcf_hrs;

uint8_t dcf_is_on; // eingeschaltet
uint8_t dcf_active; // Gerade ein Interrupt (!= dcf_on)
uint8_t dcf_break_timer;
uint8_t dcf_bit_pos;
uint8_t dcf_high_timer;

uint8_t dcf_bits[58]; //dcf77 hat 58+1 bit jeweils 1 wird im sekundentakt geschickt

void dcf_init();
void dcf_on();
void dcf_off();
uint8_t dcf_parse();

void dcf_ISRoutine();
void dcf_INT_Routine();

#endif

